---
title: ServiceWorkerGlobalScope.onmessage
slug: Web/API/ServiceWorkerGlobalScope/onmessage
tags:
  - API
  - Property
  - Reference
  - Service
  - ServiceWorker
  - ServiceWorkerGlobalScope
  - Workers
  - onmessage
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <strong>onmessage</strong> property of the {{domxref("ServiceWorkerGlobalScope")}} interface is an event handler fired whenever a {{domxref("ServiceWorkerGlobalScope.message_event","message")}} event occurs — when incoming messages are received.</p>

<div class="note">
<p><strong>Note</strong>: Service workers define the extendable event to allow extending the lifetime of the event. For the <code>message</code> event, service workers use the {{domxref("ExtendableMessageEvent")}} interface which extends the {{domxref("ExtendableEvent")}} interface.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Messages received from service worker contexts (e.g. as the event object of <code>onmessage</code>) are represented by {{domxref("MessageEvent")}} objects in modern browsers, for consistency with other web messaging features. (They used to be represented by {{domxref("ServiceWorkerMessageEvent")}} objects, which have now been deprecated.)</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>serviceWorkerGlobalScope</em>.onmessage = function(<em>extendableMessageEvent</em>) { ... };</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">self.addEventListener('message', function(messageEvent) {
  console.log('Handling message event:', messageEvent);
})
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#service-worker-global-scope-event-handlers', 'Event Handlers')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerGlobalScope.onmessage")}}</p>
</div>
